
#ifndef __SRC_SQLITECONFIGTIMERSSTORE_H__
#define __SRC_SQLITECONFIGTIMERSSTORE_H__

#include <glib.h>
#include <glib-object.h>
#include <gee/list.h>
#include "src/ConfigStore.h"
#include "src/TimersStore.h"
#include "src/DeviceGroup.h"
#include "src/Device.h"
#include "src/Timer.h"

G_BEGIN_DECLS


#define DVB_TYPE_SQLITE_CONFIG_TIMERS_STORE (dvb_sqlite_config_timers_store_get_type ())
#define DVB_SQLITE_CONFIG_TIMERS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_SQLITE_CONFIG_TIMERS_STORE, DVBSqliteConfigTimersStore))
#define DVB_SQLITE_CONFIG_TIMERS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_SQLITE_CONFIG_TIMERS_STORE, DVBSqliteConfigTimersStoreClass))
#define DVB_IS_SQLITE_CONFIG_TIMERS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_SQLITE_CONFIG_TIMERS_STORE))
#define DVB_IS_SQLITE_CONFIG_TIMERS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_SQLITE_CONFIG_TIMERS_STORE))
#define DVB_SQLITE_CONFIG_TIMERS_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_SQLITE_CONFIG_TIMERS_STORE, DVBSqliteConfigTimersStoreClass))

typedef struct _DVBSqliteConfigTimersStore DVBSqliteConfigTimersStore;
typedef struct _DVBSqliteConfigTimersStoreClass DVBSqliteConfigTimersStoreClass;
typedef struct _DVBSqliteConfigTimersStorePrivate DVBSqliteConfigTimersStorePrivate;

struct _DVBSqliteConfigTimersStore {
	GObject parent_instance;
	DVBSqliteConfigTimersStorePrivate * priv;
};

struct _DVBSqliteConfigTimersStoreClass {
	GObjectClass parent_class;
};


gboolean dvb_sqlite_config_timers_store_contains_group (DVBSqliteConfigTimersStore* self, guint group_id);
gboolean dvb_sqlite_config_timers_store_contains_timer (DVBSqliteConfigTimersStore* self, guint timer_id);
DVBSqliteConfigTimersStore* dvb_sqlite_config_timers_store_construct (GType object_type);
DVBSqliteConfigTimersStore* dvb_sqlite_config_timers_store_new (void);
GType dvb_sqlite_config_timers_store_get_type (void);


G_END_DECLS

#endif
