
#ifndef __SRC_RTSP_MEDIAMAPPING_H__
#define __SRC_RTSP_MEDIAMAPPING_H__

#include <glib.h>
#include <glib-object.h>
#include <gst/rtsp-server/rtsp-media-mapping.h>
#include <gst/rtsp-server/rtsp-media-factory.h>
#include <gst/rtsp/gstrtspconnection.h>

G_BEGIN_DECLS


#define DVB_TYPE_MEDIA_MAPPING (dvb_media_mapping_get_type ())
#define DVB_MEDIA_MAPPING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_MEDIA_MAPPING, DVBMediaMapping))
#define DVB_MEDIA_MAPPING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_MEDIA_MAPPING, DVBMediaMappingClass))
#define DVB_IS_MEDIA_MAPPING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_MEDIA_MAPPING))
#define DVB_IS_MEDIA_MAPPING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_MEDIA_MAPPING))
#define DVB_MEDIA_MAPPING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_MEDIA_MAPPING, DVBMediaMappingClass))

typedef struct _DVBMediaMapping DVBMediaMapping;
typedef struct _DVBMediaMappingClass DVBMediaMappingClass;
typedef struct _DVBMediaMappingPrivate DVBMediaMappingPrivate;

struct _DVBMediaMapping {
	GstRTSPMediaMapping parent_instance;
	DVBMediaMappingPrivate * priv;
};

struct _DVBMediaMappingClass {
	GstRTSPMediaMappingClass parent_class;
};


DVBMediaMapping* dvb_media_mapping_construct (GType object_type);
DVBMediaMapping* dvb_media_mapping_new (void);
GType dvb_media_mapping_get_type (void);


G_END_DECLS

#endif
